//Hunt v1.0 - Copyright(c) 1998 by JD Glaser NT OBJECTives
//SMB share enumerator and admin finder

 ********************************************************************
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 1, or (at your option)
 *  any later version. *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details. *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 


#include <windows.h>
#include <lm.h>
#include <stdio.h>
#include <iostream.h>

void EstablishNullSession(LPCWSTR lpwServer, BOOL bEstablish);
void DoNetUserEnum(const wchar_t* lpwServer);
int  GetAdmin(char* pServer, char* pUser);
void PrintHelp();

// Vars for enum users
WCHAR RemoteResource[UNCLEN + 5 + 1]; // Length of UNC path + IPC$ + NULL

void wmain(int argc, wchar_t* argv[])
{

	// check if running on Windows NT, if not, display notice and terminate 
    if( GetVersion() & 0x80000000 ) 
    { 
      printf("Hunt only runs on Windows NT...");
      return; 
    }

    if(argc != 2)
	{
        PrintHelp();
        return;
    }

	if((0 == strcmp(argv[1], "/")) || (0 == strcmp(argv[1], "/")))
	{
		PrintHelp();
		return;
	}

	EstablishNullSession(argv[1], TRUE);

    return;
}

void EstablishNullSession(LPCWSTR lpwServer, BOOL bEstablish)
{

    LPCWSTR lpszIPC = L"\\IPC$";
    DWORD dwServer;
	DWORD dwError;
	DWORD dwEntriesRead;
	DWORD dwTotalEntries;

    NET_API_STATUS  netStatus;
    USE_INFO_2      userInfo2;
	SHARE_INFO_1*   pShareInfo1 = NULL;

	int iLoop;
    char sharename[256];
	char remark[256];

    // do not allow NULL or empty server name
    if(lpwServer == NULL || *lpwServer == L'\0')
	{
        SetLastError(ERROR_INVALID_COMPUTERNAME);
        return;
    }

    dwServer = lstrlenW(lpwServer);

    if(lpwServer[0] != L'\\' && lpwServer[1] != L'\\')
	{
        // prepend slashes and NULL terminate
        RemoteResource[0] = L'\\';
        RemoteResource[1] = L'\\';
        RemoteResource[2] = L'\0';
    }
    else
	{
        dwServer -= 2; // remove unc slashes
        RemoteResource[0] = L'\0';
    }

    if(dwServer > CNLEN)
	{
        SetLastError(ERROR_INVALID_COMPUTERNAME);
        return;
    }

	if(lstrcatW(RemoteResource, lpwServer) == NULL) return;
    if(lstrcatW(RemoteResource, lpszIPC) == NULL) return;


         ZeroMemory(&userInfo2, sizeof(userInfo2));

        userInfo2.ui2_local = NULL;
        userInfo2.ui2_remote = (LPTSTR) RemoteResource;
        userInfo2.ui2_asg_type = USE_IPC;
        userInfo2.ui2_password = (LPTSTR) L"";
		userInfo2.ui2_username = (LPTSTR) L"";
		userInfo2.ui2_domainname = (LPTSTR) L"";

        netStatus = NetUseAdd(NULL, 2, (LPBYTE)&userInfo2, NULL);
		dwError = GetLastError();
		if( netStatus != NERR_Success ) 
		{
			if(netStatus == 1219)
			{
				printf(" - NULL Session already exists\n -");
			}
			else
	           printf("Error = %d\n", GetLastError());
		}

    	netStatus = NetShareEnum(lpwServer, 1, (LPBYTE*)&pShareInfo1,
						MAX_PREFERRED_LENGTH, 
						&dwEntriesRead, 
						&dwTotalEntries, NULL);

		dwError = GetLastError();
		if( netStatus != NERR_Success ) 
		{
           printf("Error = %d\n", netStatus);
		}

    
		for(iLoop=0; iLoop<(int)dwTotalEntries; iLoop++)
		{

				// Convert the Unicode full name to ANSI.
				WideCharToMultiByte(CP_ACP, 0, pShareInfo1->shi1_netname, -1,
									sharename, 256, NULL, NULL ); 


				WideCharToMultiByte(CP_ACP, 0, pShareInfo1->shi1_remark, -1,
									remark, 256, NULL, NULL ); 

				wprintf(L"share = %S - %S\n",sharename,remark);

				pShareInfo1++;
		}

		// Enum the users
		DoNetUserEnum(lpwServer);

		// Kill the connection
        netStatus = NetUseDel(NULL, (LPTSTR) RemoteResource, 0);

    return;
}


void DoNetUserEnum(const wchar_t* lpwServer)
{	
	USER_INFO_10* pBuff, *pCurrInfo;
	DWORD dwRead, dwTotalRemaining, dwResume, dwRetCode, dwLoopCnt, dwServer;
	char user[256];
	char userServer[256];
	int iGotAdmin;

	dwResume = 0;
	dwServer = 0;
	iGotAdmin = 0;

    // Do not allow NULL or empty server name
    if(lpwServer == NULL || *lpwServer == L'\0')
	{
        SetLastError(ERROR_INVALID_COMPUTERNAME);
        return;
    }

    dwServer = lstrlenW(lpwServer);

	if(lpwServer[0] != L'\\' && lpwServer[1] != L'\\')
	{
		// Prepend slashes and NULL terminate
		RemoteResource[0] = L'\\';
		RemoteResource[1] = L'\\';
		RemoteResource[2] = L'\0';
	}
	else
	{
		dwServer -= 2; // remove unc slashes
		RemoteResource[0] = L'\0';
	}

	if(dwServer > CNLEN)
	{
		SetLastError(ERROR_INVALID_COMPUTERNAME);
		return;
	}

	if(lstrcatW(RemoteResource, lpwServer) == NULL) return;

	do	
	{
		pBuff = NULL;
		dwRetCode = NetUserEnum(RemoteResource, 10, 0, (BYTE**) &pBuff, 2048,
						&dwRead, &dwTotalRemaining, &dwResume);
		if (dwRetCode != ERROR_MORE_DATA && dwRetCode != ERROR_SUCCESS)	
			break;

		for (dwLoopCnt = 0, pCurrInfo = pBuff; dwLoopCnt < dwRead; ++ dwLoopCnt, ++ pCurrInfo) 
		{
			printf("User = %S", pCurrInfo->usri10_name);
			printf(", %S", pCurrInfo->usri10_full_name);
			printf(", %S", pCurrInfo->usri10_usr_comment);
			printf(", %S", pCurrInfo->usri10_comment);

			printf("\n");

				// Convert the Unicode full name to ANSI.
				WideCharToMultiByte(CP_ACP, 0, pCurrInfo->usri10_name, -1,
						user, 256, NULL, NULL); 
				// Convert the Unicode full name to ANSI.
				WideCharToMultiByte(CP_ACP, 0, lpwServer, -1,
						userServer, 256, NULL, NULL); 

          if(!iGotAdmin)
		  {
			// Call this function with char strings
		   iGotAdmin = GetAdmin(userServer, user);
		  }
		}
		if (pBuff != NULL)
			NetApiBufferFree(pBuff);
	} while (dwRetCode == ERROR_MORE_DATA);

	if (dwRetCode != ERROR_SUCCESS)
		printf("NUE() returned %lu\n", dwRetCode);
}

int GetAdmin(char* pServer, char* pUser)
{
	char szDomainName[256];
	SID_NAME_USE use;
	PSID pUserSID;                       
	DWORD dwSize;                         
	DWORD dwAdminVal;
	DWORD dwDomainName;
	int iRetVal;    
	int iSubCount;

	// General return code
	dwDomainName = 256;
	dwSize = 0;
     
	dwAdminVal = 0;
	iSubCount = 0;

	//Query for buffer size 
	iRetVal = LookupAccountName(pServer,         
								pUser, pUserSID,
								&dwSize, szDomainName,
								&dwDomainName, &use);
	iRetVal = GetLastError();

			//Allocate a larger buffer if error = too small 
			if(iRetVal == ERROR_INSUFFICIENT_BUFFER)
			{
				pUserSID = (PSID) malloc(dwSize);
				iRetVal = LookupAccountName(pServer,
									   pUser, pUserSID,
									   &dwSize, szDomainName, 
									   &dwDomainName, &use);
			 } 
	
     //Scan the SIDS checking for a match to ADMIN == 500 
	 iSubCount = (int)*(GetSidSubAuthorityCount(pUserSID));   // address of security identifier to query);
     
	 dwAdminVal = *(GetSidSubAuthority(pUserSID, iSubCount-1));
     if(dwAdminVal==500)
	 {
	    printf("Admin is %s\\%s\n", szDomainName, pUser);
		return 1;
	 }
	 return 0;
}

void PrintHelp()
{
	printf("Hunt v1.2 - Copyright(c) 1998, NT OBJECTives, Inc.\n");
	printf("SMB share enumerator and admin finder \n");
	printf("Programming by JD Glaser - All Rights Reserved\n");
	printf("\tUsage - hunt \\\\servername\n");
	printf("\t/? = Help\n");
	printf("See http://www.ntobjectives.com for updates/fixes");
	return;
}
