/*
 * Name : fpf ( FingerPrint Fucker ) Date : Mon Jan 08 2001 Author : cthulhu
 * (cthulhu@pkcrew.org)
 * 
 * Packet Knights Crew (www.pkcrew.org)
 * 
 * Greetz : All the pkcs , (cyrax and asynchro expecially for the help),
 *          DanteAlig, q[binary],Commport5 and kilrid
 * 
 * Usage : kldload ./fpf.ko (change the parameters via the sysctl command in
 * order to emulate various os).
 * This Kld was tested on FreeBSD 4.0 RELEASE 0#
 * 
 * This Kld creates some new sysctl var in order to change some aspects of the
 * stack.
 * 
 * The new sysctls are :
 * 
 * net.inet.fpf.T2_Resp 		int
 * net.inet.fpf.T7_Spp 			int
 * net.inet.fpf.DFwhenconnect		int
 * net.inet.fpf.DFdefault 		int	
 * net.inet.fpf.Window 			string
 * net.inet.fpf.Windefault		string
 * net.inet.fpf.AckWhenReset 		int
 * net.inet.fpf.Ops 			string
 * net.inet.fpf.Tos			string
 * net.inet.fpf.Change_ID 		int
 * net.ient.fpf.Ripck 			int
 * net.inet.fpf.Fuck_Uck		int
 * net.inet.fpf.Icmplen			int
 * 
 * Please check out the nmap-os-fingerPrints file and Fusys ' parser to
 * learn how to change the stack.
 * 
 */

#include <sys/param.h>
#include <sys/systm.h>
#include <sys/malloc.h>
#include <sys/mbuf.h>
#include <sys/kernel.h>
#include <sys/proc.h>
#include <sys/socket.h>
#include <sys/socketvar.h>
#include <sys/sysctl.h>
#include <sys/protosw.h>

#include <net/if.h>
#include <net/route.h>

#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/in_pcb.h>
#include <netinet/ip.h>
#include <netinet/ip_var.h>
#include <netinet/ip_icmp.h>
#include <netinet/tcp.h>
#include <netinet/udp.h>
#include <netinet/tcp_var.h>
#include <netinet/tcpip.h>

#define DEFAULT_BSD_OPTLEN 4
#define mwin(str) (strtol(str,NULL,16))

static int      (*fr_savep) __P((struct ip *, int, void *, int, struct mbuf **));
extern int      (*fr_checkp) __P((struct ip *, int, void *, int, struct mbuf **));

extern u_short fr_tcpsum __P((struct mbuf *, struct ip *, struct tcphdr *));
extern u_short ipf_cksum __P((u_short, int));

static int fpf_init __P((void));
static int fpf_destroy __P((void));

int fpf_check   __P((struct ip *, int, void *, int, struct mbuf **));
int fpf_checkincoming __P((struct ip *, int, void *, struct mbuf **));

void fpf_checkopt __P((void));

MALLOC_DECLARE(M_SAVEDATA);
MALLOC_DEFINE(M_SAVEDATA, "data", "saved data");

char            fpf_Opt[40];
int             fpf_OptLen;

/*
 * Change This vars in order to emulate various oses
 */

/*
 * Various Setting for the TCP Packets
 * 
 */
SYSCTL_DECL(_net_inet);
SYSCTL_NODE(_net_inet, OID_AUTO, fpf, CTLFLAG_RW, 0, "FPF");

static int      fpf_T2_Resp = 0;
SYSCTL_INT(_net_inet_fpf, OID_AUTO, T2_Resp, CTLFLAG_RW, &fpf_T2_Resp, 0, "");

static int      fpf_T7_Spp = 1;
SYSCTL_INT(_net_inet_fpf, OID_AUTO, T7_Spp, CTLFLAG_RW, &fpf_T7_Spp, 0, "");

static int      DFwhenConnect = 0;
SYSCTL_INT(_net_inet_fpf, OID_AUTO, DFwhenconnect, CTLFLAG_RW,
	   &DFwhenConnect, 0, "");

static int      DFdefault = 0;
SYSCTL_INT(_net_inet_fpf, OID_AUTO, DFdefault, CTLFLAG_RW, &DFdefault, 0, "");

static char     WINDOW[5] = "402E";
SYSCTL_STRING(_net_inet_fpf, OID_AUTO, Window, CTLFLAG_RW,
	      WINDOW, sizeof(WINDOW), "");

static char     WINDOWdefault[5] = "0";
SYSCTL_STRING(_net_inet_fpf, OID_AUTO, WinDefault, CTLFLAG_RW,
	      WINDOWdefault, sizeof(WINDOWdefault), "");

static int      ACK_WHEN_RESET = 1;
SYSCTL_INT(_net_inet_fpf, OID_AUTO, AckWhenReset, CTLFLAG_RW,
	   &ACK_WHEN_RESET, 0, "");

static char     Ops[TCP_MAXOLEN] = "WNME";
SYSCTL_STRING(_net_inet_fpf, OID_AUTO, Ops, CTLFLAG_RW,
	      Ops, sizeof(Ops), "");

/*
 * Setting for the icmp packet handling
 */
static char     Tos[3] = "C0";
SYSCTL_STRING(_net_inet_fpf, OID_AUTO, Tos, CTLFLAG_RW,
	      Tos, sizeof(Tos), "");

static int      Change_ID = 1;
SYSCTL_INT(_net_inet_fpf, OID_AUTO, Change_ID, CTLFLAG_RW, &Change_ID, 0, "");

static int      Ripck = -1;
SYSCTL_INT(_net_inet_fpf, OID_AUTO, Ripck, CTLFLAG_RW, &Ripck, 0, "");

static int      Fuck_Uck = -1;
SYSCTL_INT(_net_inet_fpf, OID_AUTO, Fuck_Uck, CTLFLAG_RW, &Fuck_Uck, 0, "");

static int      ICMPLEN = 48;
SYSCTL_INT(_net_inet_fpf, OID_AUTO, IcmpLen, CTLFLAG_RW, &ICMPLEN, 0, "");


static int
fpf_modevent(module_t mod, int type, void *nouse)
{
	int             error = 0;

	switch (type) {
	case MOD_LOAD:
		error = fpf_init();
		break;

	case MOD_UNLOAD:
		error = fpf_destroy();
		break;

	default:
		error = EINVAL;
		break;
	}

	return error;
}

static moduledata_t fpf_mod = {
	"FpF",
	fpf_modevent,
	NULL
};

DECLARE_MODULE(FpF, fpf_mod, SI_SUB_PROTO_DOMAIN, SI_ORDER_ANY);

static int
fpf_init(void)
{
	int             s;

	s = splnet();

	if (fr_checkp == fpf_check) {
		uprintf("The FingerPrint Fucker is already running \n");
		return -1;
	}
	fpf_checkopt();

	fr_savep = fr_checkp;
	fr_checkp = fpf_check;

	splx(s);

	printf("\n -=    FingerPrint Fucker kld       =-\n");
	printf("\n -= by cthulhu (cthulhu@pkcrew.org) =-\n");
	printf(" -=         www.pkcrew.org          =-\n");
	return 0;
}

static int
fpf_destroy(void)
{
	int             s;

	s = splnet();

	fr_checkp = fr_savep;
	fr_savep = NULL;

	splx(s);

	uprintf("FingerPrint Fucker Unloaded\n");
	return 0;
}

void
fpf_checkopt(void)
{
	int             i = 0, j = 0;
	u_short        *conv;

	while (i < strlen(Ops) + 1) {
		if (Ops[i] == '|') {
			Ops[i] = '\0';
			break;
		}
		i++;
	}

	if (strlen(Ops) == 0) {
		Ops[0] = '0';
		Ops[1] = '\0';
	}
	for (i = 0; i < strlen(Ops); i++) {

		switch ((u_char) Ops[i]) {
		case 'W':
			fpf_Opt[j] = 3;
			++j;
			fpf_Opt[j] = 3;
			++j;
			fpf_Opt[j] = 123;
			++j;
			break;
		case 'N':
			fpf_Opt[j] = 1;
			++j;
			break;
		case 'T':
			fpf_Opt[j] = 8;
			++j;
			fpf_Opt[j] = 10;
			++j;
			j += 8;
			break;
		case 'M':
			fpf_Opt[j] = 2;
			++j;
			fpf_Opt[j] = 4;
			++j;
			if ((i + 1) <= strlen(Ops)) {

				if (Ops[i + 1] == 'E') {
					conv = (u_short *) (fpf_Opt + j);
					*conv = htons(265);
				} else {
					fpf_Opt[j] = 123;
					fpf_Opt[j + 1] = 123;
				}

				j += 2;
			}
			break;
		case 'L':
			fpf_Opt[j] = 0;
			++j;
			if (j > ((j / 4) * 4)) {
				j = (j / 4) * 4 + 4;
			}
			break;
		case '0':
			j = 0;
			i = strlen(Ops);
			break;
		}
	}

	fpf_OptLen = j;
}

int
fpf_check(ip, hlen, ifp, out, mbp)
	int             out;
	int             hlen;
	struct ip      *ip;
	void           *ifp;
	struct mbuf   **mbp;
{
	struct tcphdr  *tcp;
	struct icmp    *icmp;
	struct ip      *riph;
	struct udphdr  *udph;
	int             optlen, tcplen, iplen;
	int             totlen, len;
	int             datalen ;
	int             i = 0;
	u_char         *option;
	u_char         *data;
	struct mbuf    *m = *mbp;

	if (ip->ip_p != IPPROTO_TCP && ip->ip_p != IPPROTO_ICMP) {
		return 0;
	}
	if (!out && ip->ip_p == IPPROTO_TCP) {
		fpf_checkincoming(ip, hlen, ifp, mbp);
	}
	/*
	 * Here begins the TCP packet Handling
	 */
	if (ip->ip_p == IPPROTO_TCP) {

		tcp = (struct tcphdr *) ((char *) ip + hlen);
		tcplen = (tcp->th_off << 2);
		iplen = (ip->ip_hl << 2);
		totlen = ip->ip_len;
		datalen = totlen - (iplen + tcplen);
		optlen = tcplen - sizeof(struct tcphdr);

		MALLOC(data, u_char *, datalen, M_SAVEDATA, M_WAITOK);

		if (DFdefault)
			ip->ip_off |= IP_DF;
		else
			ip->ip_off &= ~(IP_DF);

		if (tcp->th_win != 0) {
			tcp->th_win = htons(mwin(WINDOW));

			if (DFwhenConnect)
				ip->ip_off |= IP_DF;
			else
				ip->ip_off &= ~(IP_DF);
		} else
			tcp->th_win = htons(mwin(WINDOWdefault));

		if ((tcp->th_flags & TH_RST) && ACK_WHEN_RESET)
			tcp->th_flags |= TH_ACK;

		if ((optlen >= DEFAULT_BSD_OPTLEN)) {
			fpf_checkopt();
			option = (u_char *) (tcp + 1);

			bzero(data, datalen);
			bcopy(option + optlen, data, datalen);

			for (i = 0; i < fpf_OptLen; i++) {
				option[i] = fpf_Opt[i];
			}

			optlen = fpf_OptLen;

			bcopy(data, option + optlen, datalen);

			tcp->th_off = (sizeof(struct tcphdr) + optlen) >> 2;
			tcplen = tcp->th_off << 2;

			ip->ip_len = iplen + tcplen + datalen;

			m->m_len = ip->ip_len;
#if      BSD >= 199306
			m->m_pkthdr.len = m->m_len;
#endif
		}
		FREE(data, M_SAVEDATA);

		ip->ip_sum = 0;
		ip->ip_sum = in_cksum(m, hlen);

		tcp->th_sum = 0;
		tcp->th_sum = fr_tcpsum(m, ip, tcp);

		return 0;
	}
	/*
	 * Icmp Packet Handling
	 */

	if (ip->ip_p == IPPROTO_ICMP) {
		icmp = (struct icmp *) ((char *) ip + hlen);

		if (icmp->icmp_type != ICMP_UNREACH ||
		    icmp->icmp_code != ICMP_UNREACH_PORT) {
			return 0;
		}
		len = ntohs(ip->ip_len) - (ip->ip_hl << 2) -
			sizeof(struct icmp);

		if (len >= 148) {
			ip->ip_tos = mwin(Tos);
			ip->ip_len = (ip->ip_hl << 2) + sizeof(struct icmp) +
				ICMPLEN;

			riph = (struct ip *) (&icmp->icmp_ip);
			udph = (struct udphdr *) (icmp + 1);

			/*
			 * FreeBSD answers RID=F. We can emulate only oses
			 * with RID=0
			 */
			if (!Change_ID)
				riph->ip_id = htons(0);

			/*
			 * FreeBSD answers this test with RIPCK=F. We can
			 * only emulate oses with RIPCK=0 cause it's not
			 * possibile to recomutate the checksum
			 */
			if (!Ripck)
				riph->ip_sum = 0;

			/*
			 * Fuck_UCK FreeBSD Answer with UCK=0. We can only
			 * emulate some oses with UCK=F because it's not
			 * possibile to recomputate the checksum of this udp
			 * packet for the oses that answers with UCK=E
			 */
			if (Fuck_Uck)
				udph->uh_sum = htons(1234);

			m->m_len = ip->ip_len;
#if	BSD >= 199306
			m->m_pkthdr.len = m->m_len;
#endif
			icmp->icmp_cksum = in_cksum(m, sizeof(struct icmp) +
						    ICMPLEN);
		}
	}
	return 0;
}

/*
 * This function checks the incoming tcp packets in order to change the T2
 * and T7 answers
 */

int
fpf_checkincoming(ip, hlen, ifp, mbp)
	int             hlen;
	struct ip      *ip;
	void           *ifp;
	struct mbuf   **mbp;
{

	struct tcphdr  *tcp;
	struct mbuf    *m = *mbp;

	tcp = (struct tcphdr *) ((char *) ip + hlen);

	if ((!(tcp->th_flags & TH_FIN)) && (!(tcp->th_flags & TH_RST))
	    && (!(tcp->th_flags & TH_SYN)) && (!(tcp->th_flags & TH_PUSH))
	    && (!(tcp->th_flags & TH_URG)) && (!tcp->th_ack)) {

		if (fpf_T2_Resp) {

			tcp->th_flags |= (TH_PUSH);
			tcp->th_flags |= (TH_FIN);
			tcp->th_flags |= (TH_URG);
			tcp->th_dport = htons(1);

			tcp->th_sum = 0;
			tcp->th_sum = fr_tcpsum(m, ip, tcp);
		}
	}
	if ((tcp->th_flags & TH_FIN) && (tcp->th_flags & TH_PUSH)
	    && (tcp->th_flags & TH_URG) && (!(tcp->th_flags & TH_RST))
	    && (!(tcp->th_flags & TH_SYN)) && (!tcp->th_ack)) {

		if (fpf_T7_Spp) {

			tcp->th_flags &= ~(TH_FIN);
			tcp->th_flags &= ~(TH_URG);
			tcp->th_flags &= ~(TH_PUSH);
			tcp->th_flags |= TH_SYN;

			tcp->th_sum = 0;
			tcp->th_sum = fr_tcpsum(m, ip, tcp);
		}
	}
	return 0;
}
